#include <iostream>
#include <vector>
using namespace std;

int main()
{
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

    size_t number_count, bin_count, i, bin;
    cerr << "Enter number count: " << endl;
    cin>>number_count;
    vector<double> numbers(number_count);
    cerr<< "Enter numbers: "<<endl;
    for (size_t i = 0; i < number_count; i++){
        cin>>numbers[i];
    }
    double min = numbers[0];
    double max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }

    cerr<< "Enter bin count: "<<endl;
    cin>>bin_count;
    vector<size_t> bins(bin_count);
    double bin_size = (max - min) / bin_count;

    for (size_t i = 0; i < number_count; i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
            }
    }
    size_t height = 0;
    size_t max_count = 0;
    for (i = 0; i < bin_count; i++){
        if (bins[i] > max_count) max_count = bins[i];
    }
    for(size_t bin:bins){
        size_t height = bin;
        height = MAX_ASTERISK * (static_cast<double>(bin) / max_count);
        if(bin<100) cout<<" ";
        if(bin<10) cout<<" ";
        cout<<bin<<"|";
        for(size_t i = 0; i < height; i++){
            cout<<"*";
        }
        cout<<endl;
    }
}
